---------------------------------------------------------------------------------------------------
-- Export plugin for Gforcefactory EDGE 6D
-- Version 1.0
-- Export start
---------------------------------------------------------------------------------------------------

Myfunction =

{
Start=function(self)
	package.path = package.path..";.\\LuaSocket\\?.lua"
	package.cpath = package.cpath..";.\\LuaSocket\\?.dll"
	socket = require("socket")

	my_init = socket.protect(function()
		host1 = host1 or "255.255.255.255"
		port1 = port1 or 50010
		c = socket.udp ( )
		c:settimeout ( 0 )
		c:setpeername ( host1, port1 )
	end)
	my_init()
end,


AfterNextFrame=function(self)

	local t = LoGetModelTime()
	local pitch, bank, yaw = LoGetADIPitchBankYaw()
	local accel = LoGetAccelerationUnits()
	local rot_vel = LoGetAngularVelocity()

	my_send = socket.protect(function()
		if c then
			socket.try(c:send(string.format("G0,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,", t*1000, accel.x*1000, accel.y*1000, accel.z*1000, bank*1000, pitch*1000, yaw*1000, rot_vel.x*1000, rot_vel.y*1000,rot_vel.z*1000)))

			end
	end)
	my_send()

end,


Stop=function(self)
	my_close = socket.protect(function()
		if c then
			c:close()
		end
	end)
	my_close()
end
}


-- =============
-- Overload
-- =============

-- Works once just before mission start.
do
	local PrevLuaExportStart=LuaExportStart
	LuaExportStart=function()
		Myfunction:Start()
		if PrevLuaExportStart then
			PrevLuaExportStart()
		end
	end
end

-- Works just after every simulation frame.
do
	local PrevLuaExportAfterNextFrame=LuaExportAfterNextFrame
	LuaExportAfterNextFrame=function()
		Myfunction:AfterNextFrame()
		if PrevLuaExportAfterNextFrame then
			PrevLuaExportAfterNextFrame()
		end
	end
end

-- Works once just after mission stop.
do
	local PrevLuaExportStop=LuaExportStop
	LuaExportStop=function()
		Myfunction:Stop()
		if PrevLuaExportStop then
			PrevLuaExportStop()
		end
	end
end
